Index: src/uk/me/parabola/imgfmt/app/net/RouteArc.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/net/RouteArc.java	(revision 929)
+++ src/uk/me/parabola/imgfmt/app/net/RouteArc.java	(working copy)
@@ -43,7 +43,7 @@
 
 	private int offset;
 
-	private final byte initialHeading;
+	private byte initialHeading;
 	private byte endDirection;
 
 	private final RoadDef roadDef;
@@ -190,6 +190,9 @@
 		return (int) (l * factor);
 	}
 
+	final static int NUDGE_DEG = -15;
+	final static int NUDGE = NUDGE_DEG * 256 / 360;
+
 	public void write(ImgFileWriter writer) {
 		offset = writer.position();
 		log.debug("writing arc at", offset, ", flagA=", Integer.toHexString(flagA));
@@ -197,6 +200,10 @@
 		// fetch destination class -- will have been set correctly by now
 		setDestinationClass(dest.getNodeClass());
 
+		// XXX: nudge headout for arcs leading to lower class roads
+		if (dest.getNodeClass() - source.getNodeClass() < 0)
+			initialHeading += NUDGE;
+
 		// determine how to write length and curve bit
 		int[] lendat = encodeLength();
 
Index: resources/styles/default/lines
===================================================================
--- resources/styles/default/lines	(revision 928)
+++ resources/styles/default/lines	(working copy)
@@ -23,10 +23,10 @@
 highway=footway [0x16 road_class=0 road_speed=0 resolution 23]
 highway=minor [0x06 road_class=1 road_speed=2 resolution 21]
 highway=motorway {add oneway = yes } [0x01 road_class=4 road_speed=6 resolution 12]
-highway=motorway_link [0x01 road_class=4 road_speed=3 resolution 16]
+highway=motorway_link [0x01 road_class=3 road_speed=3 resolution 16]
 highway=pedestrian & area!=yes [0x06 road_class=0 road_speed=0 resolution 22]
 highway=primary [0x02 road_class=3 road_speed=4 resolution 19]
-highway=primary_link [0x03 road_class=3 road_speed=3 resolution 19]
+highway=primary_link [0x03 road_class=2 road_speed=3 resolution 19]
 highway=residential | highway=living_street [0x06 road_class=0 road_speed=2 resolution 21]
 highway=secondary [0x04 road_class=2 road_speed=3 resolution 20]
 highway=path [0x16 road_class=0 road_speed=0 resolution 20]
@@ -35,7 +35,7 @@
 highway=tertiary [0x05 road_class=1 road_speed=3 resolution 20]
 highway=track [0x0a road_class=0 road_speed=1 resolution 21]
 highway=trunk  [0x02 road_class=3 road_speed=5 resolution 16]
-highway=trunk_link [0x02 road_class=3 road_speed=3 resolution 16]
+highway=trunk_link [0x02 road_class=2 road_speed=3 resolution 16]
 highway=unclassified [0x06 road_class=1 road_speed=2 resolution 21]
 highway=unsurfaced [0x0a road_class=0 road_speed=1 resolution 21]
 
